<?php
/**
* Plugin pluxml2mastodon
*
* @package	PLX
* @version	1.0
* @date	03/12/19
* @author Bronco
**/
class pluxml2mastodon extends plxPlugin {
	private $article_content;
	private $instance_URL;
	private $api_key;
	private $visibility;
	private $header_message;
	private $footer_message;
	private $balises=[
		'%TITLE',
		'%URL',
		'%TAGS',
		'%LINK',
	];

	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);		
		
		# limite l'acces a l'ecran de configuration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		
		
		$this->instance_URL=$this->getParam("instance_URL");
		$this->api_key=$this->getParam("api_key");
		$this->visibility=$this->getParam("visibility");
		$this->header_message=$this->getParam("header_message");
		$this->footer_message=$this->getParam("footer_message");



		# Declaration d'un hook (existant ou nouveau)
		$this->addHook('plxAdminEditArticle','plxAdminEditArticle');
		$this->addHook('plxAdminEditArticleEnd','plxAdminEditArticleEnd');

		
	}

	# Activation / desactivation
	public function OnActivate() {
		# code à executer à l’activation du plugin
	}
	public function OnDeactivate() {
		# code à executer à la désactivation du plugin
	}
	public function setArticleContent($content) {
		$this->article_content=$content;echo '1';var_dump($content);
	}

	private function replaceBy($str='',array $array){
		$str=str_replace($this->balises,$array,$str);
		return str_replace('\n',"\n",$str);
	}

	public function post2Mastodon($data=null){
		if (
			!$data
			|| empty($this->instance_URL)
			|| empty($this->api_key)
		){return false;}
		$headers = [
		  'Authorization: Bearer '.$this->api_key
		];
		
		$ch_status = curl_init();
		curl_setopt($ch_status, CURLOPT_URL, $this->instance_URL.'/api/v1/statuses');
		curl_setopt($ch_status, CURLOPT_POST, 1);
		curl_setopt($ch_status, CURLOPT_POSTFIELDS, $data);
		curl_setopt($ch_status, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch_status, CURLOPT_HTTPHEADER, $headers);

		$output_status = json_decode(curl_exec($ch_status));

		curl_close ($ch_status);
		return $output_status;
	}	

	########################################
	# HOOKS
	########################################


	# hook pour récupérer les données de l'article
	public function plxAdminEditArticle(){
		echo '<?php 
			$content["id"]=$id;
			$this->plxPlugins->aPlugins["pluxml2mastodon"]->setArticleContent($content)

		?>';
		
	}
	#hook pour composer et poster sur mastodon
	public function plxAdminEditArticleEnd(){
		
		if (
			!empty($_POST['draft'])
			||!empty($_POST['update'])
			||!empty($_POST['preview'])
			|| empty($_POST)
			|| (
					  empty($_POST['chapo']) 
					&&empty($_POST['content']) 
					&&empty($_POST['title'])
				)
		){
			# On ne publie pas un brouillon, un article déjà publié avant mais modifié etc.
			return;
		}

		$title=$this->article_content['title'];
		$link=!empty($this->article_content['url_link'])?"\n".$this->article_content['url_link']."\n":'';
		$plxMotor=plxMotor::getInstance();

		$lang=$plxMotor->aConf['default_lang'];
		$root=$plxMotor->aConf['racine'];
		$content=!empty($this->article_content['chapo'])?$this->article_content['chapo']:$this->article_content['content'];
		$content=preg_replace('#<spoiler>[^^]*?<\/spoiler>#', '*CONTIENT DES SPOILERS*', $content);

		$content=strip_tags($content).$link;

		$tags=array_filter(explode(',',$this->article_content['tags']));
		$tags_string='';
		foreach ($tags as $tag) {
			$tags_string.=' #'.preg_replace('#[^a-zA-Z0-9]#','',$tag);
		}
		$tags_string="\n".trim($tags_string);

		if ($this->header_message){
			$this->header_message.="\n";
		}
		if ($this->footer_message){
			$this->footer_message="\n".$this->footer_message;
		}

		$url=$this->article_content['url'];
		
		$url = $plxMotor->urlRewrite('?article'.$this->article_content['id'].'/'.$url);


		#replacements
		$content=$this->replaceBy($this->header_message.$content.$this->footer_message,[$title,$url,$tags_string,$link]);

		if (strlen($content)>500){
			$content=substr($content,0,494).' [...]';
		}
		
		$data=[
			'status'=> $content,
			'language'=>$lang,
			'visibility' => $this->visibility
		];

		$this->post2Mastodon($data);
	}

	

}





/* Pense-bete:
 * Récuperer des parametres du fichier parameters.xml
 *	$this->getParam("<nom du parametre>")
 *	$this-> setParam ("param1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_PLUGINS
 * PLX_CONFIG_PATH
 * PLX_ADMIN (true si on est dans admin)
 * PLX_CHARSET
 * PLX_VERSION
 * PLX_FEED
 *
 * Appel de HOOK dans un thème
 *	eval($plxShow->callHook("ThemeEndHead","param1"))  ou eval($plxShow->callHook("ThemeEndHead",array("param1","param2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","param1"));
 */